diff --git a/src/main/java/net/minecraft/core/net/command/commands/SeedCommand.java b/src/main/java/net/minecraft/core/net/command/commands/SeedCommand.java
index 8aff21c0f..77845be9e 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/SeedCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/SeedCommand.java
@@ -1,64 +1,19 @@
 package net.minecraft.core.net.command.commands;
 
-import java.awt.Toolkit;
-import java.awt.datatransfer.Clipboard;
-import java.awt.datatransfer.StringSelection;
-
-import net.minecraft.core.world.World;
-import net.minecraft.core.net.command.TextFormatting;
-import net.minecraft.core.net.command.Command;
-import net.minecraft.core.net.command.CommandError;
-import net.minecraft.core.net.command.CommandHandler;
-import net.minecraft.core.net.command.CommandSender;
-import net.minecraft.core.net.command.PlayerCommandSender;
-import net.minecraft.core.net.command.ServerCommandHandler;
-
-public class SeedCommand extends Command{
-
-	public SeedCommand() {
-		super("seed");
-	}
-
-	@Override
-	public boolean execute(CommandHandler handler, CommandSender sender, String[] args) {
-		World world = null;
-		
-		if(sender instanceof PlayerCommandSender) {
-			world = sender.getPlayer().world;
-		}
-		
-		if(handler instanceof ServerCommandHandler) {
-			if(args.length > 0) {
-				ServerCommandHandler server = (ServerCommandHandler) handler;
-				int dim = Integer.parseInt(args[0]);
-				
-				world = server.minecraftServer.getDimensionWorld(dim);
-			}
-		}
-		
-		if(world == null) throw new CommandError("Must be used by a player, or a dimension must be defined!");
-		
-		sender.sendMessage("Seed: " + TextFormatting.LIME + world.getRandomSeed());
-		
-		if(handler.isClient()) {
-			Clipboard clipboard = Toolkit.getDefaultToolkit().getSystemClipboard();
-			clipboard.setContents(new StringSelection(String.valueOf(world.getRandomSeed())), null);
-			sender.sendMessage("Copied to clipboard!");
-		}
-		return true;
-	}
-
-	@Override
-	public boolean opRequired(String[] args) {
-		return true;
-	}
-
-	@Override
-	public void sendCommandSyntax(CommandHandler handler, CommandSender sender) {
-		if(sender instanceof PlayerCommandSender) {
-			sender.sendMessage("/seed");
-		}
-		sender.sendMessage("/seed <dimension>");
-	}
-
+import com.mojang.brigadier.Command;
+import com.mojang.brigadier.CommandDispatcher;
+import com.mojang.brigadier.builder.LiteralArgumentBuilder;
+import net.minecraft.core.net.command.CommandSource;
+
+public class SeedCommand {
+    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+        dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("seed")
+                .requires(CommandSource::hasAdmin)
+                .executes(c -> {
+                    CommandSource source = c.getSource();
+                    source.sendTranslatableMessage("command.commands.seed.success", source.getWorld().getRandomSeed());
+                    return Command.SINGLE_SUCCESS;
+                })
+        );
+    }
 }
diff --git a/src/main/java/net/minecraft/core/net/command/commands/SetBlockCommand.java b/src/main/java/net/minecraft/core/net/command/commands/SetBlockCommand.java
index f57fd4e2b..7fdc85895 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/SetBlockCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/SetBlockCommand.java
@@ -1,127 +1,46 @@
 package net.minecraft.core.net.command.commands;
 
-import net.minecraft.core.block.Block;
-import net.minecraft.core.block.Blocks;
-import net.minecraft.core.net.command.Command;
-import net.minecraft.core.net.command.CommandError;
-import net.minecraft.core.net.command.CommandHandler;
-import net.minecraft.core.net.command.CommandSender;
-
-public class SetBlockCommand extends Command{
-
-	public SetBlockCommand() {
-		super("setblock");
-	}
-
-	@Override
-	public boolean execute(CommandHandler handler, CommandSender sender, String[] args) {
-		if(args.length < 4) return false;
-		if(!sender.isPlayer()) throw new CommandError("Must be sent by a player!");
-
-		int blockIDOffset;
-
-		int x1 = Integer.parseInt(args[0]);
-		int y1 = Integer.parseInt(args[1]);
-		int z1 = Integer.parseInt(args[2]);
-		int x2, y2, z2;
-
-		if (args.length == 4)
-		{
-			x2 = x1;
-			y2 = y1;
-			z2 = z1;
-			blockIDOffset = 3;
-		}
-		else if (args.length == 7)
-		{
-			x2 = Integer.parseInt(args[3]);
-			y2 = Integer.parseInt(args[4]);
-			z2 = Integer.parseInt(args[5]);
-			blockIDOffset = 6;
-		}
-		else
-		{
-			return false;
-		}
-
-		// Swap parameters if needed
-		if (x1 > x2)
-		{
-			int temp = x1;
-			x1 = x2;
-			x2 = temp;
-		}
-		if (y1 > y2)
-		{
-			int temp = y1;
-			y1 = y2;
-			y2 = temp;
-		}
-		if (z1 > z2)
-		{
-			int temp = z1;
-			z1 = z2;
-			z2 = temp;
-		}
-		
-		String[] id = args[blockIDOffset].split(":");
-		
-		int meta = 0;
-		
-		if(id.length >= 2) {
-			meta = Integer.parseInt(id[1]);
-		}
-		
-		int blockId = getBlock(id[0], meta);
-		if (blockId == -1) return false;
-
-		for (int x = x1; x <= x2; x++)
-		{
-			for (int z = z1; z <= z2; z++)
-			{
-				for (int y = y1; y <= y2; y++)
-				{
-					sender.getPlayer().world.setBlockAndMetadataWithNotify(x, y, z, blockId, meta);
-				}
-			}
-		}
-
-		return true;
-	}
-
-	@Override
-	public boolean opRequired(String[] args) {
-		return true;
-	}
-
-	@Override
-	public void sendCommandSyntax(CommandHandler handler, CommandSender sender) {
-		sender.sendMessage("/setblock <x> <y> <z> <block>");
-		sender.sendMessage("/setblock <x1> <y1> <z1> <x2> <y2> <z2> <block>");
-	}
-	
-	public static Block getBlock(int id) {
-		return Block.blocksList[id];
-	}
-	
-	public static int getBlock(String id, int meta) {
-		try {
-			int i = Integer.parseInt(id);
-			if (i == 0 || Block.blocksList[i] != null)
-			{
-				return i;
-			}
-			else return -1;
-		}catch (Exception e) {
-			String id2 = "tile."+id;
-			for(Block block : Block.blocksList) {
-				if(block != null) {
-					if(block.getKey().equalsIgnoreCase(id)) return block.id;
-					if(block.getKey().equalsIgnoreCase(id2)) return block.id;
-				}
-			}
-			return -1;
-		}
-	}
-
+import com.mojang.brigadier.Command;
+import com.mojang.brigadier.CommandDispatcher;
+import com.mojang.brigadier.builder.LiteralArgumentBuilder;
+import com.mojang.brigadier.builder.RequiredArgumentBuilder;
+import com.mojang.brigadier.exceptions.SimpleCommandExceptionType;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.world.World;
+import net.minecraft.core.net.command.util.CommandHelper;
+import net.minecraft.core.net.command.CommandSource;
+import net.minecraft.core.net.command.arguments.*;
+import net.minecraft.core.net.command.helpers.BlockInput;
+import net.minecraft.core.net.command.helpers.IntegerCoordinates;
+
+public class SetBlockCommand {
+    private static final SimpleCommandExceptionType FAILURE = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("command.commands.setblock.exception_failure"));
+
+    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+        dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("setblock")
+                .requires(CommandSource::hasAdmin)
+                .then(RequiredArgumentBuilder.<CommandSource, IntegerCoordinates>argument("position", IntegerCoordinatesArgumentType.intCoordinates())
+                        .then(RequiredArgumentBuilder.<CommandSource, BlockInput>argument("block", BlockArgumentType.block())
+                                .executes(c -> {
+                                    CommandSource source = c.getSource();
+                                    IntegerCoordinates coordinates = c.getArgument("position", IntegerCoordinates.class);
+                                    BlockInput blockInput = c.getArgument("block", BlockInput.class);
+                                    World world = source.getWorld();
+
+                                    int x = coordinates.getX(source);
+                                    int y = coordinates.getY(source, true);
+                                    int z = coordinates.getZ(source);
+
+                                    if (!world.isBlockLoaded(x, y, z)) {
+                                        throw FAILURE.create();
+                                    } else {
+                                        world.setBlockWithNotify(x, y, z, blockInput.getBlockId());
+                                        world.setBlockMetadataWithNotify(x, y, z, blockInput.getMetadata());
+                                        CommandHelper.setBlockEntity(world, x, y, z, blockInput.getTag());
+                                        source.sendTranslatableMessage("command.commands.setblock.success", coordinates.getX(source), coordinates.getY(source, true), coordinates.getZ(source));
+                                    }
+
+                                    return Command.SINGLE_SUCCESS;
+                                }))));
+    }
 }
diff --git a/src/main/java/net/minecraft/core/net/command/commands/SetSpawnCommand.java b/src/main/java/net/minecraft/core/net/command/commands/SetSpawnCommand.java
index e59663dbb..fd27ebdf1 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/SetSpawnCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/SetSpawnCommand.java
@@ -1,64 +1,35 @@
 package net.minecraft.core.net.command.commands;
 
+import com.mojang.brigadier.Command;
+import com.mojang.brigadier.CommandDispatcher;
+import com.mojang.brigadier.builder.LiteralArgumentBuilder;
+import com.mojang.brigadier.builder.RequiredArgumentBuilder;
+import com.mojang.brigadier.tree.CommandNode;
 import net.minecraft.core.world.chunk.ChunkCoordinates;
-import net.minecraft.core.entity.player.Player;
-import net.minecraft.core.world.World;
-import net.minecraft.core.net.command.Command;
-import net.minecraft.core.net.command.CommandError;
-import net.minecraft.core.net.command.CommandHandler;
-import net.minecraft.core.net.command.CommandSender;
-import net.minecraft.core.net.command.PlayerCommandSender;
+import net.minecraft.core.net.command.CommandSource;
+import net.minecraft.core.net.command.arguments.IntegerCoordinatesArgumentType;
+import net.minecraft.core.net.command.helpers.IntegerCoordinates;
 
-public class SetSpawnCommand extends Command{
+public class SetSpawnCommand {
+    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+        CommandNode<CommandSource> command = dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("setworldspawn")
+                .requires(CommandSource::hasAdmin)
+                .then(RequiredArgumentBuilder.<CommandSource, IntegerCoordinates>argument("position", IntegerCoordinatesArgumentType.intCoordinates())
+                        .executes(c -> {
+                            CommandSource source = c.getSource();
+                            IntegerCoordinates coordinates = c.getArgument("position", IntegerCoordinates.class);
 
-	public SetSpawnCommand() {
-		super("setworldspawn", "setspawn");
-	}
+                            int x = coordinates.getX(source);
+                            int y = coordinates.getY(source, true);
+                            int z = coordinates.getZ(source);
 
-	@Override
-	public boolean execute(CommandHandler handler, CommandSender sender, String[] args) {
-		Player player = sender.getPlayer();
-		
-		int x, y, z;
-		
-		if(args.length > 0) {
-			try {
-				x = Integer.parseInt(args[0]);
-				y = Integer.parseInt(args[1]);
-				z = Integer.parseInt(args[2]);
-			}
-			catch (NumberFormatException nfe){
-				throw new CommandError("Coordinates must be integers!");
-			}
-		}else {
-			if(player == null) throw new CommandError("Must be used by a player, or define coordinates!");
-			
-			x = (int) Math.floor(player.x);
-			y = (int) Math.floor(player.y);
-			z = (int) Math.floor(player.z);
-		}
-		
-		ChunkCoordinates pos = new ChunkCoordinates(x, y, z);
-		World world = handler.getWorld(0);
-		world.setSpawnPoint(pos);
-		handler.sendCommandFeedback(sender, "Set spawn location to x: "+x+" y: "+y+" z: "+z);
-		
-		return true;
-	}
+                            source.getWorld().setSpawnPoint(new ChunkCoordinates(x, y, z));
+                            source.sendTranslatableMessage("command.commands.setspawn.success", x, y, z);
 
-	@Override
-	public boolean opRequired(String[] args) {
-		return true;
-	}
-
-	@Override
-	public void sendCommandSyntax(CommandHandler handler, CommandSender sender) {
-		if(sender instanceof PlayerCommandSender) {
-			sender.sendMessage("/setworldspawn");
-		}
-		sender.sendMessage("/setworldspawn <x> <y> <z>");
-	}
-	
-	
-	
+                            return Command.SINGLE_SUCCESS;
+                        })));
+        dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("setspawn")
+                .requires(CommandSource::hasAdmin)
+                .redirect(command));
+    }
 }
diff --git a/src/main/java/net/minecraft/core/net/command/commands/SpawnCommand.java b/src/main/java/net/minecraft/core/net/command/commands/SpawnCommand.java
index 86927b514..57ed015ab 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/SpawnCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/SpawnCommand.java
@@ -1,57 +1,66 @@
 package net.minecraft.core.net.command.commands;
 
-import net.minecraft.core.world.chunk.ChunkCoordinates;
+import com.mojang.brigadier.Command;
+import com.mojang.brigadier.CommandDispatcher;
+import com.mojang.brigadier.builder.LiteralArgumentBuilder;
+import com.mojang.brigadier.builder.RequiredArgumentBuilder;
+import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
-import net.minecraft.server.entity.player.ServerPlayer;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.command.exceptions.CommandExceptions;
 import net.minecraft.core.world.World;
-import net.minecraft.core.net.command.Command;
-import net.minecraft.core.net.command.CommandError;
-import net.minecraft.core.net.command.CommandHandler;
-import net.minecraft.core.net.command.CommandSender;
-import net.minecraft.core.net.command.PlayerCommandSender;
+import net.minecraft.core.world.chunk.ChunkCoordinates;
+import net.minecraft.core.net.command.util.CommandHelper;
+import net.minecraft.core.net.command.CommandSource;
+import net.minecraft.core.net.command.arguments.EntityArgumentType;
+import net.minecraft.core.net.command.helpers.EntitySelector;
 
-public class SpawnCommand extends Command{
+import java.util.List;
 
-	public SpawnCommand() {
-		super("spawn");
-	}
+public class SpawnCommand {
+    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+        dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("spawn")
+                .requires(CommandSource::hasAdmin)
+                .executes(c -> {
+                    CommandSource source = c.getSource();
+                    Player sender = source.getSender();
+                    World world = source.getWorld(0);
+                    ChunkCoordinates spawnCoordinates = world.getSpawnPoint();
 
-	@Override
-	public boolean execute(CommandHandler handler, CommandSender sender, String[] args) {
-		if(sender instanceof PlayerCommandSender) {
-			Player player = sender.getPlayer();
-			
-			World world = handler.getWorld(player);
-			
-			ChunkCoordinates pos = world.getSpawnPoint();
-			
-			sender.sendMessage("Teleporting to spawn...");
-			
-			if(player instanceof ServerPlayer) {
-				ServerPlayer playerMP = (ServerPlayer) player;
-				if(playerMP.dimension != 0) {
-					playerMP.mcServer.playerList.sendPlayerToOtherDimension(playerMP, 0, false);
-				}
-				playerMP.playerNetServerHandler.teleportAndRotate(pos.x + 0.5, pos.y + 0.5, pos.z + 0.5, 0, 0);
-			}
-			player.absMoveTo(pos.x + 0.5, pos.y + 0.5, pos.z + 0.5, 0, 0);
-			
-			return true;
-		}else {
-			throw new CommandError("Must be used by a player!");
-		}
-	}
+                    if (sender == null) throw CommandExceptions.notInWorld().create();
 
-	@Override
-	public boolean opRequired(String[] args) {
-		return true;
-	}
+                    if (sender.dimension != 0) source.movePlayerToDimension(sender, 0);
+                    sender.absMoveTo(spawnCoordinates.x + 0.5, spawnCoordinates.y, spawnCoordinates.z + 0.5, sender.yRot, sender.xRot);
+                    source.sendTranslatableMessage("command.commands.spawn.success");
+                    return Command.SINGLE_SUCCESS;
+                })
+                .then(RequiredArgumentBuilder.<CommandSource, EntitySelector>argument("players", EntityArgumentType.players())
+                        .executes(c -> {
+                            CommandSource source = c.getSource();
+                            Player sender = source.getSender();
+                            World world = source.getWorld(0);
+                            ChunkCoordinates spawnCoordinates = world.getSpawnPoint();
+                            EntitySelector entitySelector = c.getArgument("players", EntitySelector.class);
+                            List<? extends Entity> players = entitySelector.get(source);
 
-	@Override
-	public void sendCommandSyntax(CommandHandler handler, CommandSender sender) {
-		sender.sendMessage("/spawn");
-	}
-	
-	
-	
+                            for (Entity entity : players) {
+                                if (((Player)entity).dimension != 0) source.movePlayerToDimension((Player) entity, 0);
+                                entity.absMoveTo(spawnCoordinates.x + 0.5, spawnCoordinates.y, spawnCoordinates.z + 0.5, entity.yRot, entity.xRot);
+                                if (entity == sender) {
+                                    source.sendTranslatableMessage("command.commands.spawn.success");
+                                } else {
+                                    source.sendTranslatableMessage("command.commands.spawn.success_receiver");
+                                    source.sendTranslatableMessage("command.commands.spawn.success_other", CommandHelper.getEntityName(entity));
+                                }
+                            }
+                            return Command.SINGLE_SUCCESS;
+                        }))
+                .then(LiteralArgumentBuilder.<CommandSource>literal("get")
+                        .executes(c -> {
+                            CommandSource source = c.getSource();
+                            ChunkCoordinates spawnCoordinates = source.getWorld(0).getSpawnPoint();
+                            source.sendMessage(I18n.getInstance().translateKeyAndFormat("command.commands.spawn.get", spawnCoordinates.x, spawnCoordinates.y, spawnCoordinates.z));
+                            return Command.SINGLE_SUCCESS;
+                        })));
+    }
 }
diff --git a/src/main/java/net/minecraft/core/net/command/commands/SummonCommand.java b/src/main/java/net/minecraft/core/net/command/commands/SummonCommand.java
index 05aadab7b..21530fc3b 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/SummonCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/SummonCommand.java
@@ -1,109 +1,76 @@
 package net.minecraft.core.net.command.commands;
 
-import java.util.Set;
-
-import com.mojang.logging.LogUtils;
+import com.mojang.brigadier.Command;
+import com.mojang.brigadier.CommandDispatcher;
+import com.mojang.brigadier.arguments.IntegerArgumentType;
+import com.mojang.brigadier.builder.LiteralArgumentBuilder;
+import com.mojang.brigadier.builder.RequiredArgumentBuilder;
+import com.mojang.brigadier.context.CommandContext;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.EntityDispatcher;
+import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
-import net.minecraft.core.net.command.TextFormatting;
-import net.minecraft.core.net.command.Command;
-import net.minecraft.core.net.command.CommandError;
-import net.minecraft.core.net.command.CommandHandler;
-import net.minecraft.core.net.command.CommandSender;
-import net.minecraft.core.net.command.LocationTarget;
-import net.minecraft.core.net.command.PlayerCommandSender;
-import org.jetbrains.annotations.NotNull;
-import org.slf4j.Logger;
+import net.minecraft.core.net.command.util.CommandHelper;
+import net.minecraft.core.net.command.CommandSource;
+import net.minecraft.core.net.command.arguments.EntitySummonArgumentType;
+import net.minecraft.core.net.command.arguments.Vec3ArgumentType;
+import net.minecraft.core.net.command.exceptions.CommandExceptions;
+import net.minecraft.core.net.command.helpers.DoubleCoordinates;
+
+public class SummonCommand {
+    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+        dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("summon")
+                .requires(CommandSource::hasAdmin)
+                .then(RequiredArgumentBuilder.<CommandSource, Class<? extends Entity>>argument("entity", EntitySummonArgumentType.entity())
+                        .executes(c -> {
+                            CommandSource source = c.getSource();
+                            Vec3 coordinates = source.getCoordinates(false);
+                            if (source.getSender() == null || coordinates == null) throw CommandExceptions.notInWorld().create();
+
+                            Entity entity = summonEntityAt(c, coordinates.x, coordinates.y - source.getSender().heightOffset, coordinates.z, 0.0f, 0.0f);
+
+                            source.sendTranslatableMessage("command.commands.summon.success_single_entity", CommandHelper.getEntityName(entity));
+
+                            return Command.SINGLE_SUCCESS;
+                        })
+                        .then(RequiredArgumentBuilder.<CommandSource, DoubleCoordinates>argument("position", Vec3ArgumentType.vec3d())
+                                .executes(c -> {
+                                    CommandSource source = c.getSource();
+                                    DoubleCoordinates coordinates = c.getArgument("position", DoubleCoordinates.class);
+
+                                    Entity entity = summonEntityAt(c, coordinates.getX(source), coordinates.getY(source, true), coordinates.getZ(source), 0.0f, 0.0f);
+
+                                    source.sendTranslatableMessage("command.commands.summon.success_single_entity", CommandHelper.getEntityName(entity));
 
-public class SummonCommand extends Command{
-	private static final Logger LOGGER = LogUtils.getLogger();
-	public SummonCommand() {
-		super("summon");
-	}
+                                    return Command.SINGLE_SUCCESS;
+                                })
+                                .then(RequiredArgumentBuilder.<CommandSource, Integer>argument("amount", IntegerArgumentType.integer(1, 255))
+                                        .executes(c -> {
+                                            CommandSource source = c.getSource();
+                                            DoubleCoordinates coordinates = c.getArgument("position", DoubleCoordinates.class);
+                                            int amount = c.getArgument("amount", Integer.class);
 
-	@Override
-	public boolean execute(CommandHandler handler, CommandSender sender, String[] args) {
-		if(args.length == 0) return false;
-		
-		if(args[0].equalsIgnoreCase("list")) {
-			StringBuilder builder = new StringBuilder().append(TextFormatting.LIGHT_GRAY).append("Entities: ").append(TextFormatting.WHITE);
-			int i=0;
-			for(String string : EntityDispatcher.keyToClassMap.keySet()) {
-				if(i > 0) {
-					builder.append(", ");
-				}
-				builder.append(string);
-				i++;
-			}
-			sender.sendMessage(builder.toString());
-			return true;
-		}
-		
-		Set<String> keySet = EntityDispatcher.keyToClassMap.keySet();
-		
-		String entityID = args[0];
-		Class<? extends Entity> entityClass = null;
-		
-		for(String str : keySet) {
-			if(str.equalsIgnoreCase(entityID)) {
-				entityID = str;
-				entityClass = EntityDispatcher.keyToClassMap.get(entityID);
-			}
-		}
-		
-		if(entityClass == null) {
-			throw new CommandError("Could not find entity \""+entityID+"\"");
-		}
-		
-		LocationTarget location = new LocationTarget(handler, sender);
-		
-		int count = 1;
-		int offset = 1;
-		
-		if(args.length > 1) {
-			offset += location.parse(args, offset);
-		}
-		
-		if(args.length > offset) {
-			count = Integer.parseInt(args[offset]);
-		}
-		
-		if(handler.isServer()) {
-			count = Math.min(count, handler.asServer().minecraftServer.summonLimit);
-		}
-		
-		for(int i=0; i < count; i++) {
-			Entity entity = createEntity(entityClass, location.getWorld());
-			entity.spawnInit();
-			entity.moveTo(location.getX(), location.getY(), location.getZ(), 0, 0);
-			location.getWorld().entityJoinedWorld(entity);
+                                            for (int i = 0; i < amount; i++) {
+                                                summonEntityAt(c, coordinates.getX(source), coordinates.getY(source, true), coordinates.getZ(source), 0.0f, 0.0f);
+                                            }
 
-		}
-		
-		handler.sendCommandFeedback(sender, "Summoned "+count+" "+entityID+" at "+location);
-		return true;
-	}
-	
-	@Override
-	public boolean opRequired(String[] args) {
-		return true;
-	}
+                                            source.sendTranslatableMessage("command.commands.summon.success_multiple_entities", amount);
 
-	@Override
-	public void sendCommandSyntax(CommandHandler handler, CommandSender sender) {
-		if(sender instanceof PlayerCommandSender) {
-			sender.sendMessage("/summon <entity> <position> <count>");
-		}
-	}
-	
-	public static Entity createEntity(@NotNull Class<? extends Entity> entityClass, World world) {
-		try {
-			return entityClass.getConstructor(World.class).newInstance(world);
-		}catch (Exception e) {
-            LOGGER.warn("Could not create Entity for class '{}'!", entityClass.getSimpleName());
-			throw new CommandError("Could not create Entity!");
-		}
-	}
+                                            return Command.SINGLE_SUCCESS;
+                                        })))));
+    }
 
+    @SuppressWarnings({"SameParameterValue", "unchecked"})
+    private static Entity summonEntityAt(CommandContext<CommandSource> c, double x, double y, double z, float yaw, float pitch) {
+        Class<? extends Entity> entityClass = c.getArgument("entity", Class.class);
+        Entity entity;
+        try {
+            entity = entityClass.getConstructor(World.class).newInstance(c.getSource().getWorld());
+        } catch (Exception e) {
+            throw new RuntimeException(e);
+        }
+        entity.spawnInit();
+        entity.moveTo(x, y, z, yaw, pitch);
+        c.getSource().getWorld().entityJoinedWorld(entity);
+        return entity;
+    }
 }
